﻿using System;
using System.ComponentModel.Composition;
using System.ComponentModel.Composition.Hosting;
using System.Reflection;


namespace MEFConsoleApp1
{
    class RunDemo
    {

        //[Export("MyMEFString")]
        //string ThatExportedMefString
        //{
        //    get
        //    {
        //        return "This string was provided by an MEF contract.";
        //    }
        //}

        [Import("MyMEFString")]
        string SomeString { get; set; }

        public RunDemo()
        {
            string folderToWatch = @"C:\Development\MEF\DGCode\MEFDemo1\MEFComponent1\bin\Debug";
            var catalog = new DirectoryCatalog(folderToWatch);
            //var catalog = new AssemblyCatalog(Assembly.GetExecutingAssembly());

            var container = new CompositionContainer(catalog);
            var batch = new CompositionBatch();
            batch.AddPart(this);
            container.Compose(batch);

        }

        public void RunTheDemo()
        {

            Console.WriteLine(SomeString);

        }
    }
}
